CON
         _clkmode         = xtal1 + pll16x
        _xinfreq         = 5_000_000

        NUM              = %100
        CAPS             = %010
        SCROLL           = %001
        RepeatRate       = 40

        BufferLength     = 8                            'Sets buffer size

        FIFO             = true                         'allows FIFO style buffer if true

VAR

byte    index,kbuffer[BufferLength],buffterm   

OBJ

        term    : "tv_text"
        kb      : "keyboard"
 

PUB start | key, numero
  'start the tv terminal
  term.start(12)
  term.str(string("Keyboard Buffer Demo...",13))

  'start the keyboard
  kb.startx(26, 27, NUM+SCROLL, RepeatRate)
  buffterm := 0

  'echo keystrokes in hex
  repeat
    'term.dec(kb.getkey)
    'term.out(" ")
    key := kb.getkey
    if Keyfilter(key)
       if index < BufferLength 
          kbuffer[index] := key
          index++
       else
          if FIFO == true
             bytemove(@kbuffer[0],@kbuffer[1],BufferLength-1)
             kbuffer[BufferLength-1] := key   
    term.out(0)
    term.str(string("Keyboard Buffer Demo...",13))
    term.out(13)
    term.str(@kbuffer)
    term.out(13)
    term.out(13)
    if CompareBlock(@kbuffer,string("Parallax"),BufferLength) == true
       term.str(string("Password is valid!!",13))
    else
       term.str(string("Password is incorrect!!",13))
       
PUB  ConvertirNumero(Address1):resultado | cuenta
     cuenta := 1
     resultado := 0

     if byte[Address1+2] => 48 and byte[Address1+2] =< 57
        resultado := (byte[Address1+2] - 48)*cuenta
        cuenta := 10

     if byte[Address1+1] => 48 and byte[Address1+1] =< 57
        resultado := resultado + (byte[Address1+1] - 48)*cuenta
        cuenta := cuenta * 10

     if byte[Address1] => 48 and byte[Address1] =< 57
        resultado := resultado + (byte[Address1] - 48)*cuenta

PUB Keyfilter(key)
    result := 0
    if key < 128 
       result := 1
    if key == 9                                         'Ignore TAB key
       result := 0
    if key == 13                                        'Ignore Enter Key
       result := 0                                         
    if key == 201 or key == 200                         'Process Delete key and BackSpace key
       if index > 0                                     '(Delete one Character)
          index--
          bytefill(@kbuffer[index],0,BufferLength-index)
    if key == 196                                       'Process Home key
       index := 0                                       '(Clear buffer)
       bytefill(@kbuffer[index],0,BufferLength)
    if key == 197                                       'Process End key
       if index < BufferLength                          '(Fill remainder of buffer with SPACE)
          bytefill(@kbuffer[index],32,BufferLength-index)
          index := BufferLength

PUB CompareBlock(Address1,Address2,Length):Flag|i
    Flag := true
    repeat i from 0 to Length
      if byte[Address1+i] <> byte[Address2+i]
         Flag := false